# Conditional build (--with/--without option)
#   --without milter
%define lgwver	0.32

Summary:	An antivirus toolkit for Unix
Name:		clamav
Version:	0.75.1
Release:	1
Epoch:		59
License:	GPL
Group:		System Environment/Daemons
URL:		http://www.clamav.net/
Source0:	http://download.sf.net/clamav/%{name}-%{version}.tar.gz
Source1:	clamd.sh
Source2:	clamav-milter.sh
Source3:	freshclam.sh
Source4:	clamav-milter.sysconfig
Source5:	clamd.logrotate
Source6:	freshclam.logrotate
Source7:	http://www.schimkat.dk/clamav/clamav-logwatch-%{lgwver}.tar.gz
Source8:	RPM-clamav.txt
Source9:	RPM-clamav-milter.txt
Source10:	clamav-milter.daily
Source11:	freshclam.daily
Patch0:		clamav-0.74-sendmail-8.11.patch
Requires:	bzip2-libs gmp zlib
BuildRequires:	bzip2-devel gmp-devel zlib-devel
BuildRequires:	autoconf automake
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
Clam AntiVirus is a GPL anti-virus toolkit for UNIX. The main purpose of this
software is the integration with mail servers (attachment scanning).
The package provides a flexible and scalable multi-threaded daemon,
a command line scanner, and a tool for automatic updating via Internet.
The programs are based on a shared library distributed with package,
which you can use with your own software.
Most importantly, the virus database is kept up to date .


%if %{!?_without_milter:1}%{?_without_milter:0}
%package 	milter
Summary:	Clamav milter
Group:		System Environment/Daemons
License:	GPL
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	sendmail >= 8.11
Requires:	sendmail-cf >= 8.11
Requires:	tcp_wrappers
BuildRequires:	sendmail-devel >= 8.11
BuildRequires:	tcp_wrappers

%description 	milter
ClamAV sendmail filter using MILTER interface.
%endif

%package 	devel
Summary:	Clamav - Development header files and libraries
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description 	devel
This package contains the development header files and libraries
necessary to develope your own clamav based applications.


%prep
%setup -q
%setup -D -a 7
# Sendmail-8.11 workaround
%patch0 -p1 -b .811
#


%build
%configure \
	--program-prefix=%{?_program_prefix} \
	%{!?_without_milter:--enable-milter} \
	--disable-clamav \
	--enable-id-check \
	--with-user=clamav \
	--with-group=clamav \
	--with-dbdir=%{_localstatedir}/lib/clamav
%{__make}


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_initrddir}/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/
install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/run/clamav/
install -d $RPM_BUILD_ROOT%{_localstatedir}/spool/clamav/

%{__make} DESTDIR=$RPM_BUILD_ROOT install

%{?_without_milter:rm -f $RPM_BUILD_ROOT%{_mandir}/man8/clamav-milter.8*}
install %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/clamd
install %{SOURCE3} $RPM_BUILD_ROOT%{_initrddir}/freshclam
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/clamd
install %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/freshclam
install clamav-logwatch-%{lgwver}/clamav $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/clamav
install clamav-logwatch-%{lgwver}/clamav.conf $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/clamav.conf
install etc/clamav.conf $RPM_BUILD_ROOT%{_sysconfdir}/clamav.conf
install etc/freshclam.conf $RPM_BUILD_ROOT%{_sysconfdir}/freshclam.conf
install %{SOURCE8} RPM-clamav.txt
install %{SOURCE11} $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/freshclam
mv clamav-logwatch-%{lgwver}/HOWTO HOWTO-logwatch.txt
touch $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/clamav.log
touch $RPM_BUILD_ROOT%{_localstatedir}/log/clamav/freshclam.log

# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
install %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/clamav-milter
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/clamav-milter
install clamav-logwatch-%{lgwver}/clamav-milter $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/clamav-milter
install clamav-logwatch-%{lgwver}/clamav-milter.conf $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/clamav-milter.conf
install %{SOURCE9} RPM-clamav-milter.txt
install %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/clamav-milter
%endif
#

# Custom config files
sed -e 's!^Example!#Example!;
        s!^#LogFile .*!LogFile /var/log/clamav/clamd.log!;
        s!^#LogFileMaxSize .*!LogFileMaxSize 0!;
        s!^#LogTime!LogTime!;
        s!^#LogSyslog!LogSyslog!;
        s!^#PidFile .*!PidFile /var/run/clamav/clamd.pid!;
        s!^#TemporaryDirectory .*!TemporaryDirectory /tmp!;
        s!^#DatabaseDirectory .*!DatabaseDirectory /var/lib/clamav!;
        s!^LocalSocket .*!#LocalSocket /var/run/clamav/clamd.sock!;
        s!^#FixStaleSocket!FixStaleSocket!;
        s!^#TCPSocket .*!TCPSocket 3310!;
        s!^#TCPAddr .*!TCPAddr 127.0.0.1!;
	s!^#MaxConnectionQueueLength .*!MaxConnectionQueueLength 30!;
        s!^#StreamSaveToDisk!StreamSaveToDisk!;
	s!^#ReadTimeout .*!ReadTimeout 300!;
        s!^#User .*!User clamav!;
        s!^#AllowSupplementaryGroups!AllowSupplementaryGroups!;
        s!^#ScanMail!ScanMail!;
        s!^#ArchiveBlockEncrypted!ArchiveBlockEncrypted!;' \
        etc/clamav.conf > $RPM_BUILD_ROOT%{_sysconfdir}/clamav.conf

sed -e 's!^#DatabaseDirectory .*!DatabaseDirectory /var/lib/clamav!;
        s!^#UpdateLogFile .*!UpdateLogFile /var/log/clamav/freshclam.log!;
        s!^#DatabaseOwner .*!DatabaseOwner clamav!;
        s!^Checks .*!Checks 24!;
        s!^#NotifyClamd .*!NotifyClamd /etc/clamav.conf!;' \
        etc/freshclam.conf > $RPM_BUILD_ROOT%{_sysconfdir}/freshclam.conf
#


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%pre
if [ -z "`/usr/bin/id -g clamav 2>/dev/null`" ]; then
	/usr/sbin/groupadd -g 46 -r -f clamav 2>&1 || :
fi
if [ -z "`/usr/bin/id -u clamav 2>/dev/null`" ]; then
	/usr/sbin/useradd -u 46 -r -M -d /tmp  -s /sbin/nologin -c "Clam AntiVirus" -g clamav clamav 2>&1 || :
fi

%post
/sbin/ldconfig
/sbin/chkconfig --add clamd
/sbin/chkconfig --add freshclam

# Change back file owner for systems with non clamav user
CLAMUSER=`grep ^User /etc/clamav.conf | cut -d ' ' -f2`
if [ -z $CLAMUSER ] ; then
   CLAMUSER="clamav"
fi
if [ $CLAMUSER != "clamav" -a `/usr/bin/id $CLAMUSER > /dev/null 2>&1 ; echo $?` = 0 ] ; then
   chown root:$CLAMUSER %{_sysconfdir}/clamav.conf
   chown root:$CLAMUSER %{_sysconfdir}/freshclam.conf
   chown -R $CLAMUSER:$CLAMUSER %{_localstatedir}/lib/clamav/
   chown -R $CLAMUSER:$CLAMUSER %{_localstatedir}/log/clamav/
   chown -R $CLAMUSER:$CLAMUSER %{_localstatedir}/run/clamav/
fi
#

%preun
if [ $1 -eq 0 ]; then
	/sbin/service clamd stop > /dev/null 2>&1 || :
	/sbin/service freshclam stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del clamd
	/sbin/chkconfig --del freshclam
fi

%postun
/sbin/ldconfig
if [ $1 -eq 0 ]; then
	rm -rf %{_localstatedir}/run/clamav/
	/usr/sbin/userdel -r clamav > /dev/null 2>&1 || :
   else
	/sbin/service clamd condrestart > /dev/null 2>&1 || :
	/sbin/service freshclam condrestart > /dev/null 2>&1 || :
fi

# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
%post milter
/sbin/chkconfig --add clamav-milter

%preun milter
if [ $1 -eq 0 ]; then
	/sbin/service clamav-milter stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del clamav-milter
fi

%postun milter
if [ $1 -ge 1 ]; then
	/sbin/service clamav-milter condrestart > /dev/null 2>&1 || :
fi
%endif
#


%files
%defattr(0644,root,root,0755)
%doc AUTHORS BUGS COPYING ChangeLog FAQ INSTALL NEWS README TODO
%doc docs/*.pdf docs/html/ test/ RPM-clamav.txt HOWTO-logwatch.txt
%lang(fr) %doc docs/French
%lang(ja) %doc docs/Japanese
%lang(pl) %doc docs/Polish
%lang(pt) %doc docs/Portugese
%lang(sp) %doc docs/Spanish
%lang(tk) %doc docs/Turkish
%attr(0644,root,clamav) %config(noreplace) %{_sysconfdir}/clamav.conf
%attr(0640,root,clamav) %config(noreplace) %{_sysconfdir}/freshclam.conf
%attr(0755,root,root) %{_sysconfdir}/cron.daily/freshclam
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/clamd
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/freshclam
%attr(0755,root,root) %{_sysconfdir}/log.d/scripts/services/clamav
%attr(0644,root,root) %{_sysconfdir}/log.d/conf/services/clamav.conf
%attr(0755,root,root) %{_initrddir}/clamd
%attr(0755,root,root) %{_initrddir}/freshclam
%attr(0755,root,root) %{_bindir}/*
%attr(0755,root,root) %{_sbindir}/clamd
%attr(0755,root,root) %{_libdir}/libclamav.so*
%attr(0755,clamav,clamav) %dir %{_localstatedir}/lib/clamav/
%attr(0644,clamav,clamav) %config(noreplace) %verify(user group mode) %{_localstatedir}/lib/clamav/main.cvd
%attr(0644,clamav,clamav) %config(noreplace) %verify(user group mode) %{_localstatedir}/lib/clamav/daily.cvd
%attr(0755,clamav,clamav) %dir %{_localstatedir}/log/clamav/
%attr(0755,clamav,clamav) %dir %{_localstatedir}/run/clamav/
%attr(0640,clamav,clamav) %ghost %{_localstatedir}/log/clamav/clamav.log
%attr(0640,clamav,clamav) %ghost %{_localstatedir}/log/clamav/freshclam.log
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man8/clamd.8*

# Milter
%if %{!?_without_milter:1}%{?_without_milter:0}
%files milter
%defattr(0644,root,root,0755)
%doc RPM-clamav-milter.txt
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/clamav-milter
%attr(0755,root,root) %{_initrddir}/clamav-milter
%attr(0755,root,root) %{_sysconfdir}/cron.daily/clamav-milter
%attr(0755,root,root) %{_sysconfdir}/log.d/scripts/services/clamav-milter
%attr(0644,root,root) %{_sysconfdir}/log.d/conf/services/clamav-milter.conf
%attr(0755,root,root) %{_sbindir}/clamav-milter
%{_mandir}/man8/clamav-milter.8*
%attr(0700,clamav,clamav) %{_localstatedir}/spool/clamav/
%endif
#

%files devel
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_libdir}/*.a
%attr(0755,root,root) %{_libdir}/*.la
%attr(0644,root,root) %{_includedir}/*.h
%attr(0644,root,root) %{_libdir}/pkgconfig/libclamav.pc


%changelog
* Thu Aug 12 2004 Ryan Weaver <ryanw@falsehope.com> 0.75.1-1
- Update to 0.75.1
- 0.75.1, backported changes:
- freshclam/clamd: fix crash on PPC when LogFile was enabled together with
  LogSyslog
- configure: improve gethostbyname_r check; cleanups
- clamav-milter: Use GETHOSTBYNAME_R_6 Better load balancing if max_children = 0
- clamdscan: fix stdin scanning in local mode
  (patch by Stephen Gran <steve*lobefin.net>)
- clamav-milter: %v in the template file handling is now replaced only with the
  virus name, no "stream:" appears
- libclamav/mbox.c: Fix crash when debugging on SPARC
- libclamav/message.c: Fix occasional crash when scanning multipart within
  multipart e-mails
- clamav-milter: Fixed warning message when building on FreeBSD4.9
  Closed (small) memory leak
  Fix crash when the 1st remote service goes down
  Only use gethostbyname_r on LINUX for now Improved load balancing a bit

* Fri Jul 23 2004 Ryan Weaver <ryanw@falsehope.com> 0.75-1
- Update to 0.75
- clamav-milter: Use gethostbyname_r when available
- clamav-milter: Add mutex around gethostbyname
- clamav-milter: Add sanity check to clamfi_connect()
- libclamav/message.c: Code tidy - remove overlapping strcpy
- libclamav: Some MyDoom.I were getting through
- clamav-milter: Added --dont-wait and --advisory options
- libclamav/mbox.c: Better handling of Gibe.3 boundary exploit improves
  the speed of scanning other emails
- clamdscan: fix bug (introduced in -20040622) in stream scanning in TCP
  mode. Patch by Piotr Gackiewicz <gacek*intertele.pl>.
- libclamav/mbox.c: Some TR.Happy99.SKA were getting through
- libclamav/mbox.c: Fix compilation error on old Solaris
- libclamav/ole2_extract.c: check against recursion limits

* Wed Jun 30 2004 Ryan Weaver <ryanw@falsehope.com> 0.74-1
- Update to 0.74

* Thu Jun 3 2004 Petr Kritof <Petr|Kristof_CZ> 0.72-1
- Update to 0.72

* Wed May 19 2004 Petr Kritof <Petr|Kristof_CZ> 0.71-1
- Update to 0.71
- Update to clamav-logwatch 0.32
- Fix freshclam linuxconf problem by George Law <george|interplas_com>

* Mon May 10 2004 Petr Kritof <Petr|Kristof_CZ> 0.70-2
- Update to clamav-logwatch 0.30
- Add %post check for non clamav user file ownership
- Add freshclam cron script by Milan Kerlger <kerslage|linux_cz>
- Remove --noreject option to clamav-milter

* Sun Apr 18 2004 Petr Kritof <Petr|Kristof_CZ> 0.70-1
- Update to 0.70
- Add --noreject option to clamav-milter
- Change reload option in init scripts
- Fix tcp_wrapper dependency by Harrie Overdijk <overdijk|ecn_nl>
- Fix logrotate scripts by Jn Ondrej (SAL) <ondrejj|salstar_sk>

* Tue Mar 16 2004 Petr Kritof <Petr|Kristof_CZ> 0.70rc-1
- Update to 0.70rc
- Some spec ideas by Enrico Scholz <enrico_scholz|informatik_tu-chemnitz_de>
- Run clamav-milter with --dont-log-clean
- Use SIGHUP to rotate logs
- Enable ArchiveDetectEncrypted option

* Sun Mar 7 2004 Petr Kritof <Petr|Kristof_CZ> 0.67-2
- Fix init script locking by Luigi Iotti <luigi|iotti_biz>
- Aply clamav ulimits by Robert Schmidt <rjeschmi|eider_uwaterloo_ca>
- Compile w/o --enable-debug by Robert Schmidt <rjeschmi|eider_uwaterloo_ca>
- Fix tcp_wrapper dependencies by Mauro Vaiani <vaiani|unipi_it>
- Fix missing library link by Doru Petrescu <pdoru|from_ro>
- Increase clamav-milter max-childrens=10
- Add i18n docs files

* Mon Feb 16 2004 Petr Kritof <Petr|Kristof_CZ> 0.67-1
- Update to 0.67
- No replace config files by James Genus Jr. <jgenus|bigelow_org>

* Wed Feb 11 2004 Petr Kritof <Petr|Kristof_CZ>
- Update to clamav 0.66
- Update to clamav-logwatch 0.23
- Use TCPsocket instead LOCALsocket
- Replace /etc/sysconfig/freshclam with /etc/freshclam.conf
- Fixed dependencies by Michal Jaegermann <michal|harddata_com>
- Add clamav-milter.daily to cleanup quarantine spool
- Add test/* suite to %doc by Peter A. Gomez <pgomez|bscbellevue_com>

* Sun Dec 7 2003 Petr Kritof <Petr|Kristof_CZ>
- Fix Epoch dependencies by Eduardo Kaftanski <eduardo|linuxcenter_cl>

* Sun Nov 23 2003 Petr Kritof <Petr|Kristof_CZ>
- Update .spec file
- Fix RH-7.3 program-prefix by Kenneth Porter <shiva|sewingwitch_com>
- Rebuild on FC-1

* Sun Nov 16 2003 Petr Kritof <Petr|Kristof_CZ>
- Fix doc errors
- Fix dependencies
- Patch for RH-7.3 by Lionel Bouton <Lionel.Bouton|inet6_fr>
- Patch for RH-7.3 by Chris de Vidal <chris|devidal_tv>
- Option --without-milter by Jn Ondrej (SAL) <ondrejj|salstar_sk>

* Wed Nov 12 2003 Petr Kritof <Petr|Kristof_CZ>
- Removed package db
- Added LogWatch support
- Added FreshClam support
- Moved logfiles to own subdirectory
- Update to 0.65

* Wed Sep 10 2003 Petr Kritof <Petr|Kristof_CZ>
- Option for build without clamavdb

* Thu Jul 10 2003 Petr Kritof <Petr|Kristof_CZ>
- Split package to clamav, db, milter, devel

* Sun Jun 22 2003 Petr Kritof <Petr|Kristof_CZ>
- Update to 0.60

* Tue Jun 10 2003 Petr Kritof <Petr|Kristof_CZ>
- Fixed post, preun, postun scripts
- Update to 2003xxxx snapshots

* Tue Feb 4 2003 Petr Kritof <Petr|Kristof_CZ>
- Rebuild on RH-8.0

* Sun Dec 1 2002 Petr Kritof <Petr|Kristof_CZ>
- Based on PLD package
- Initial RH-7.3 build

